/*
 * SpriteBuilder: http://www.spritebuilder.org
 *
 * Copyright (c) 2012 Zynga Inc.
 * Copyright (c) 2013 Apportable Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#import "CCBKeyframe.h"

@implementation CCBKeyframe

- (id)init
{
    self = [super init];
    if (!self) return NULL;
    
    // Defaults
    _value              = nil;
    _time               = 0.0f;
    _easingType         = 0;
    _easingOpt          = 0.0f;
    _frameActions       = nil;
    
    return self;
}

- (NSString *) description {
    
    NSString *description = [NSString localizedStringWithFormat:@"[CCAnimationKeyframe] value: %@, time: %f, easingType: %d, easingOpt: %f", self.value, self.time,self.easingType,self.easingOpt];
    
    return description;
}

- (id)copyWithZone:(NSZone *)zone
{
	CCBKeyframe * copyKeyframe = [[self class] allocWithZone:zone];
	copyKeyframe->_value = self->_value;
	copyKeyframe->_time = self->_time;
	copyKeyframe->_easingType = self->_easingType;
	copyKeyframe->_easingOpt = self->_easingOpt;

	return copyKeyframe;
}
@end
